#!/usr/bin/python2.4
# flags.py - Numerical constants for results and flags
# Copyright (C) 2006  Christian Aichinger <Greek0@gmx.net>
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

RES_OK = 0
RES_WARN = 1
RES_ERR = 2
RES_ABORT = 4
RES_SKIP = 8

FLG_SYM_NOT_FOUND = 1
FLG_EXCEPTION = 2
FLG_CANNOT_UNPACK = 4
FLG_DO_CHECK_FAIL = 8
FLG_DEP_RESOLUTION = 16
FLG_ELF_IN_ARCH_ALL = 32
FLG_TOO_MUCH_NEEDED = 64
FLG_TEXTREL = 128

def severity(result):
    if result & RES_SKIP:
        return RES_SKIP
    elif result & RES_ABORT:
        return RES_ABORT
    elif result & RES_ERR:
        return RES_ERR
    elif result & RES_WARN:
        return RES_WARN
    else:
        return RES_OK
