#!/usr/bin/python2.4
# hacks.py - Centralized place for hacks needed in checklib
# Copyright (C) 2006  Christian Aichinger <Greek0@gmx.net>
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import copy

# The problem this solves is that packages depend on libsdl1.2debian, which
# itself doesn't contain any shlibs, but depends on the actual library package.
mangle_map = {
    'libsdl1.2debian': 'libsdl1.2debian-all',
    'libglu1-xorg': 'libglu1-mesa',
    'xlibmesa-glu': 'libglu1-mesa',
    'xlibmesa-gl': 'libgl1-mesa-glx',
    'gdk-imlib1': 'gdk-imlib11',
    'heroes-sdl': 'libsdl1.2debian-all', #hacky one
    'svgalibg1': 'libsvga1',
    'pciutils': 'libpci2',
    'libxapian-dev': 'libxapian11',
    'libfam0c102': 'libfam0',
    'radiusclient1': 'libradius1',
}

def mangle_package_name(name):
    if name in mangle_map:
        return mangle_map[name]
    return name

ignore_sym_types = {
    'R_386_GLOB_DAT': None,
    'R_386_RELATIVE': None,
}
def sym_not_found_ok(symbol):
    return symbol.rel_type in ignore_sym_types

#def skip_sym_p(symbol):
#    return symbol.rel_type in ignore_sym_types


# Normally we drop files from ulib if filename!=soname.
# This saves a lot of space, however for some libraries this causes problems
# We hack around this here:
#mismatch_ok_pkg = {
#    'libldap2': None,
#    'aolserver4': None,
#    'openoffice.org-core': None,
#    'libpt-1.10.0': None,
#    'r-base-core': None,
#    'libevent1': None,
#}
#def soname_mismatch_ok(pkgname, fname):
#    return pkgname in mismatch_ok_pkg
#
#def post_process_lib(orig_name, ulibpkg):
#    if orig_name == 'gdk-imlib1':
#        ulib = [ulib for ulib in ulibpkg.libs if ulib.lib_filename == '/usr/lib/libgdk_imlib.so.2'][0]
#        ulib_new = copy.copy(ulib)
#        ulib_new.lib_filename = '/usr/lib/libgdk_imlib.so.1'
#        ulibpkg.libs.append(ulib_new)


# Multiple libraries were found and do_check can't decide for one.
# Handle this here
def select_from_multiple_libs(soname, results):
    if soname == 'liblapack.so.3':
        return results[0]
    if soname == 'libCynthiune.so.0':
        return results[0]
    if soname == 'libStepTalk.so.0':
        return results[0]
    if soname == 'libmer_rt.so':
        return results[0]
    if soname == 'libProjectCenter.so.0':
        return results[0]

    return None

# gdk-imlib1 contains libgdk_imlib.so.1, which is a symlink to .so.2, which is
# in gdk-imlib2. To make this work we resolve a gdk-imlib1 dep to gdk-imlib2,
# and just do a lookup for .so.2 when .so.1 was requested
mangle_soname_map = {
    'libgdk_imlib.so.1': 'libgdk_imlib.so.2',
}
def mangle_soname(soname):
    return mangle_soname_map.get(soname, soname)
