#!/usr/bin/python2.4
# micro.py - Small data structures holding Package, Library and Symbol info
# Copyright (C) 2006  Christian Aichinger <Greek0@gmx.net>
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

class MicroData:
    def __init__(self):
        self.id = None

class uResult(MicroData):
    @classmethod
    def from_Results(cls, pkg_name, pkg_ver, RES, FLAGS, unneeded):
        u = cls()
        u.res_pkg_name = pkg_name
        u.res_pkg_ver = pkg_ver
        u.res_result = RES
        u.res_flags = FLAGS
        u.res_unneeded = unneeded
        return u
    @classmethod
    def from_dict(cls, data):
        u = cls()
        u.id = data['id']
        u.res_pkg_name = data['res_pkg_name']
        u.res_pkg_ver = data['res_pkg_ver']
        u.res_result = data['res_result']
        u.res_flags = data['res_flags']
        u.res_unneeded = data['res_unneeded']
        u.res_comment = data['res_comment']
        return u

#class uLibraryPackage(MicroData):
#    @classmethod
#    def from_PackageInfo(cls, pkginfo):
#        u = cls()
#        u.pkg_name = pkginfo.name
#        u.pkg_ver = pkginfo.ver
#        u.libs = [uLibrary.from_Library(lib) for lib in pkginfo.libs]
#        return u
#    @classmethod
#    def from_dict(cls, data):
#        u = cls()
#        u.id = data['id']
#        u.pkg_name = data['pkg_name']
#        u.pkg_ver = data['pkg_ver']
#        u.libs = []
#        return u
#    def append_lib(self, lib):
#        self.libs.append(lib)
#
#class uLibrary(MicroData):
#    @classmethod
#    def from_Library(cls, lib):
#        u = cls()
#        u.lib_soname = lib.soname
#        u.lib_filename = lib.filename
#        u.lib_basename = lib.basename
#        u.symbols = [uExportSymbol.from_ExportSymbol(sym) for sym in lib.symbols]
#        return u
#    @classmethod
#    def from_dict(cls, data):
#        u = cls()
#        u.id = data['id']
#        u.lib_soname = data['lib_soname']
#        u.lib_filename = data['lib_filename']
#        u.lib_basename = data['lib_basename']
#        u.symbols = []
#        return u
#    def append_sym(self, sym):
#        self.symbols.append(sym)
#    def drop_symbols(self):
#        del self.symbols
#
#class uExportSymbol(MicroData):
#    @classmethod
#    def from_ExportSymbol(cls, sym):
#        u = cls()
#        u.sym_name = sym.name
#        u.sym_undef = sym.undef
#        if sym.have_versym:
#            u.sym_ver = sym.ver_name
#            u.sym_verfile = sym.ver_file
#        else:
#            u.sym_ver = None
#            u.sym_verfile = None
#        return u
#    @classmethod
#    def from_dict(cls, data):
#        u = cls()
#        u.id = data['id']
#        u.sym_name = data['sym_name']
#        u.sym_ver = data['sym_ver']
#        u.sym_verfile = data['sym_verfile']
#        u.sym_undef = data['sym_undef']
#        return u
