<root xmlns:py="http://purl.org/kid/ns#">
<?python
  Title='checklib report'
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>${Title}</title>

<script type="text/javascript">
function Go () {
  var pkg = document.forms[0].elements[0].value;
  var page;
  if (pkg.substr(0,3) == 'lib') 
      page=pkg.substr(0,4); 
  else 
      page=pkg[0];

  window.location.href = "packages." + page.toUpperCase() + "${frmurl}.html#" + pkg;
  return false;
}
</script>
</head>

<body>
<h1>${Title}</h1>
<h2>Description</h2>
<p>
I suggest reading <a
href="http://lists.debian.org/debian-devel-announce/2005/11/msg00016.html">
Vorlon's mail about the libfreetype6 transition</a> to debian-devel-announce first,
to understand the problem.
</p>
<p>
To summarize, superflous libraries on the linker command line lead to
superfluous library dependencies in the built executable, which
<code>dpkg-shlibdeps</code> turns into superfluous inter-package dependencies.
These in turn cause trouble during transitions.
</p>
<p>
Now those ELF dependencies are represented in the binary as NEEDED entries,
which e.g. <code>readelf -d <i>file</i></code> can show.
</p>
<p>
The script behind this page scans the archive, unpacking every package, looking for ELF files.
For every file found it looks at the symbols referenced in the  relocation
table and checks in which library each symbol can be found in.
Once it's done with all the symbols it checks if all NEEDED libraries have been
used in the process. If one library was not used (i.e. the binary does not use
any symbols from the library), it signals an error.
</p>

<h2>Statistics</h2>
<img style="margin: 10px;" src="graph.png" />
<ul>
    <li py:for="name in stats_order">${name.capitalize()}: ${stats[name]} 
                          (= ${stats[name]*100/stats['TOTAL']}%)</li>
</ul>

<h2>How to fix these problems</h2>
<p>
Check out the <a href="howto-fix-problems.html">How to fix problems</a> and/or the
    <a href="howto-fix-errors.html">How to fix errors</a> page.
</p>

<p>
If you have any question regarding fixing problems/errors don't hesitate to
<a href="mailto:Greek0@gmx.net">contact me</a>.
</p>

<h2>Results</h2>

<h3>Jump directly to package:</h3>
<p>
<form action="" onsubmit="return Go();">
    Name:
    <input name="package" type="text" size="60" maxlength="60" />
</form>
</p>

<h3>Browse packages by maintainer email:</h3>
<p>
<?python
new_maint_chars = []
local_list = []
for char in maint_chars:
    local_list.append(char)
    if len(local_list) == 14:
        new_maint_chars.append(local_list)
        local_list = []
if len(local_list):
    new_maint_chars.append(local_list)
?>
<table>
  <tr py:for="chars in new_maint_chars">
    <td style="padding: 5px;" py:for="char in chars">
        <?python lnk = 'maintainers.'+char+frmurl+'.html' ?>
        <a href="${lnk}">${char}</a>
    </td>
  </tr>
</table>
</p>

<h3>Browse packages by name:</h3>
<p>
<?python
new_pkg_chars = []
local_list = []
for char in pkg_chars:
    local_list.append(char)

    if len(local_list) == 13:
        new_pkg_chars.append(local_list)
        local_list = []

if len(local_list):
    new_pkg_chars.append(local_list)
?>
<table>
  <tr py:for="chars in new_pkg_chars">
    <td style="padding: 5px;" py:for="char in chars">
        <?python lnk = 'packages.'+char+frmurl+'.html' ?>
        <a href="${lnk}">${char.upper()}</a>
    </td>
  </tr>
</table>
</p>

<h3>Browse packages by status:</h3>
<p>
<table>
    <tr>
        <td style="padding: 5px;" py:for="status in ['NOTICE', 'PROBLEM', 'ERROR']">
            <a href="status.${status}${frmurl}.html">${status}</a>
        </td>
    </tr>
</table>
</p>

<div py:content="document(INDIR+'/footer.html')"></div>
</body>
</html>
</root>
