<root xmlns:py="http://purl.org/kid/ns#">
<?python
  TITLE='checklib report'
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>${TITLE}</title>
</head>
<body>
<h1>${TITLE}</h1>

<p>
<a href="frames.html?p=${fname}">This page using frames, for slicker log browsing.</a>
</p>

<div py:content="document(INDIR+'/statuscodes.html')"></div>

<h2>Results by ${sortedby}: '${char.upper()}'</h2>
<table border="1">
  <tr>
    <th>Package</th>
    <th>Version</th>
    <th>Status</th>
    <th>Flags</th>
    <th>Log</th>
    <th>Comment</th>
  </tr>
  <tr py:for="res in sorted(results, key=lambda r: r.res_pkg_name)">
    <?python
      from checklib import flags
      short_result = res.res_result_str
      log_color = logcolors[short_result]
      sym_not_found = bool(res.res_flags & flags.FLG_SYM_NOT_FOUND)
      text_relocations = bool(res.res_flags & flags.FLG_TEXTREL)
      dep_resolution = bool(res.res_flags & flags.FLG_DEP_RESOLUTION)
      elf_in_arch_all = bool(res.res_flags & flags.FLG_ELF_IN_ARCH_ALL)
      cannot_unpack = bool(res.res_flags & flags.FLG_CANNOT_UNPACK)
    ?>
    <td py:content="res.res_pkg_name" />
    <td py:content="res.res_pkg_ver" />
    <td style="background-color: ${log_color}; color: #000;" py:content="short_result" />
    <td>
        <a href="#chkl-notfound" title="Some symbols could not be found in any library" 
            style="text-decoration:none;" py:if="sym_not_found">NF</a> 
        <a href="#chkl-textrel" title="A binary contains text relocations"
            style="text-decoration:none;" py:if="text_relocations">TR</a>
        <a href="#chkl-dep-res" title="Could not resolve package dependencies"
            style="text-decoration:none;" py:if="dep_resolution">DEP</a>
        <a href="#chkl-wah" title="Packages is arch:all but contains ELF binaries"
            style="text-decoration:none;" py:if="elf_in_arch_all">WAH!</a>
        <a href="#chkl-unpack" title="Could not unpack the binary package"
            style="text-decoration:none;" py:if="cannot_unpack">UNP</a>
    </td>
    <td><a name="${res.res_pkg_name}" target="_self" href="${res.logfile}" py:content="'log'" /></td>
    <td py:content="res.res_comment" />
  </tr>
</table>

<div py:content="document(INDIR+'/footer.html')"></div>
</body>
</html>
</root>
